Simon Glass | 38d6b8d | 2011-10-15 05:48:21 +0000 | [diff] [blame] | 1 | # |
| 2 | # Copyright (c) 2011 The Chromium OS Authors. |
| 3 | # |
| 4 | # See file CREDITS for list of people who contributed to this |
| 5 | # project. |
| 6 | # |
| 7 | # This program is free software; you can redistribute it and/or |
| 8 | # modify it under the terms of the GNU General Public License as |
| 9 | # published by the Free Software Foundatio; either version 2 of |
| 10 | # the License, or (at your option) any later version. |
| 11 | # |
| 12 | # This program is distributed in the hope that it will be useful, |
| 13 | # but WITHOUT ANY WARRANTY; without even the implied warranty of |
| 14 | # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the |
| 15 | # GNU General Public License for more details. |
| 16 | # |
| 17 | # You should have received a copy of the GNU General Public License |
| 18 | # along with this program; if not, write to the Free Software |
| 19 | # Foundation, Inc., 59 Temple Place, Suite 330, Boston, |
| 20 | # MA 02111-1307 USA |
| 21 | # |
| 22 | |
| 23 | # This Makefile builds the internal U-Boot fdt if CONFIG_OF_CONTROL is |
| 24 | # enabled. See doc/README.fdt-control for more details. |
| 25 | |
| 26 | include $(TOPDIR)/config.mk |
| 27 | |
| 28 | LIB = $(obj)libdts.o |
| 29 | |
| 30 | $(if $(CONFIG_DEFAULT_DEVICE_TREE),,\ |
| 31 | $(error Please define CONFIG_DEFAULT_DEVICE_TREE in your board header file)) |
| 32 | DEVICE_TREE = $(subst ",,$(CONFIG_DEFAULT_DEVICE_TREE)) |
| 33 | |
| 34 | $(if $(CONFIG_ARCH_DEVICE_TREE),,\ |
| 35 | $(error Your architecture does not have device tree support enabled. \ |
| 36 | Please define CONFIG_ARCH_DEVICE_TREE)) |
| 37 | |
| 38 | # We preprocess the device tree file provide a useful define |
Allen Martin | 0b5bf87 | 2013-01-08 16:07:54 +0000 | [diff] [blame] | 39 | DTS_CPPFLAGS := -x assembler-with-cpp \ |
Horst Kronstorfer | 12e4429 | 2012-07-13 03:03:40 +0000 | [diff] [blame] | 40 | -DARCH_CPU_DTS=\"$(SRCTREE)/arch/$(ARCH)/dts/$(CONFIG_ARCH_DEVICE_TREE).dtsi\" \ |
Tom Warren | f623615 | 2013-02-21 12:31:27 +0000 | [diff] [blame] | 41 | -DBOARD_DTS=\"$(SRCTREE)/board/$(VENDOR)/$(BOARD)/dts/$(DEVICE_TREE).dts\" \ |
| 42 | -I$(SRCTREE)/board/$(VENDOR)/dts -I$(SRCTREE)/arch/$(ARCH)/dts |
Simon Glass | 38d6b8d | 2011-10-15 05:48:21 +0000 | [diff] [blame] | 43 | |
| 44 | all: $(obj).depend $(LIB) |
| 45 | |
| 46 | # Use a constant name for this so we can access it from C code. |
| 47 | # objcopy doesn't seem to allow us to set the symbol name independently of |
| 48 | # the filename. |
| 49 | DT_BIN := $(obj)dt.dtb |
| 50 | |
| 51 | $(DT_BIN): $(TOPDIR)/board/$(VENDOR)/dts/$(DEVICE_TREE).dts |
Wolfgang Denk | 4ec3de0 | 2012-04-19 02:36:44 +0000 | [diff] [blame] | 52 | rc=$$( \ |
| 53 | cat $< | $(CPP) -P $(DTS_CPPFLAGS) - | \ |
| 54 | { { $(DTC) -R 4 -p 0x1000 -O dtb -o ${DT_BIN} - 2>&1 ; \ |
| 55 | echo $$? >&3 ; } | \ |
| 56 | grep -v '^DTC: dts->dtb on file' ; \ |
Stephen Warren | d292a94 | 2012-06-08 12:28:17 +0000 | [diff] [blame] | 57 | } 3>&1 1>&2 ) ; \ |
Wolfgang Denk | 4ec3de0 | 2012-04-19 02:36:44 +0000 | [diff] [blame] | 58 | exit $$rc |
Simon Glass | 38d6b8d | 2011-10-15 05:48:21 +0000 | [diff] [blame] | 59 | |
| 60 | process_lds = \ |
| 61 | $(1) | sed -r -n 's/^OUTPUT_$(2)[ ("]*([^")]*).*/\1/p' |
| 62 | |
| 63 | # Run the compiler and get the link script from the linker |
| 64 | GET_LDS = $(CC) $(CFLAGS) $(LDFLAGS) -Wl,--verbose 2>&1 |
| 65 | |
| 66 | $(obj)dt.o: $(DT_BIN) |
| 67 | # We want the output format and arch. |
| 68 | # We also hope to win a prize for ugliest Makefile / shell interaction |
| 69 | # We look in the LDSCRIPT first. |
| 70 | # Then try the linker which should give us the answer. |
| 71 | # Then check it worked. |
Horst Kronstorfer | 1783816 | 2012-07-12 02:58:32 +0000 | [diff] [blame] | 72 | [ -n "$(LDSCRIPT)" ] && \ |
| 73 | oformat=`$(call process_lds,cat $(LDSCRIPT),FORMAT)` && \ |
| 74 | oarch=`$(call process_lds,cat $(LDSCRIPT),ARCH)` ;\ |
Simon Glass | 38d6b8d | 2011-10-15 05:48:21 +0000 | [diff] [blame] | 75 | \ |
| 76 | [ -z $${oformat} ] && \ |
| 77 | oformat=`$(call process_lds,$(GET_LDS),FORMAT)` ;\ |
| 78 | [ -z $${oarch} ] && \ |
| 79 | oarch=`$(call process_lds,$(GET_LDS),ARCH)` ;\ |
| 80 | \ |
| 81 | [ -z $${oformat} ] && \ |
| 82 | echo "Cannot read OUTPUT_FORMAT from lds file $(LDSCRIPT)" && \ |
| 83 | exit 1 || true ;\ |
| 84 | [ -z $${oarch} ] && \ |
| 85 | echo "Cannot read OUTPUT_ARCH from lds file $(LDSCRIPT)" && \ |
| 86 | exit 1 || true ;\ |
| 87 | \ |
| 88 | cd $(dir ${DT_BIN}) && \ |
| 89 | $(OBJCOPY) -I binary -O $${oformat} -B $${oarch} \ |
| 90 | $(notdir ${DT_BIN}) $@ |
| 91 | rm $(DT_BIN) |
| 92 | |
| 93 | OBJS-$(CONFIG_OF_EMBED) := dt.o |
| 94 | |
| 95 | COBJS := $(OBJS-y) |
| 96 | |
| 97 | OBJS := $(addprefix $(obj),$(COBJS)) |
| 98 | |
| 99 | binary: $(DT_BIN) |
| 100 | |
| 101 | $(LIB): $(OBJS) $(DTB) |
| 102 | $(call cmd_link_o_target, $(OBJS)) |
| 103 | |
| 104 | ######################################################################### |
| 105 | |
| 106 | # defines $(obj).depend target |
| 107 | include $(SRCTREE)/rules.mk |
| 108 | |
| 109 | sinclude $(obj).depend |
| 110 | |
| 111 | ######################################################################### |